-- Adwords Keyword Generator
-- April 13, 2015

-- This SQL code must be executed after SaveToDB Framework installation!

CREATE TABLE [KeywordModel] (
    [ID] int NOT NULL IDENTITY(1,1) PRIMARY KEY, 
    [Campaign] nvarchar(50), 
    [KeywordSet] nvarchar(50), 
    [Col1] nvarchar(50), 
    [Col2] nvarchar(50), 
    [Col3] nvarchar(50), 
    [Col4] nvarchar(50), 
    [Col5] nvarchar(50), 
    [Col6] nvarchar(50), 
    [Col7] nvarchar(50)
);
GO

INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',N'*',N'*',N'option',N'data',N'*',N'*',N'excel');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',N'download',N'delayed',N'stock',N'prices',NULL,N'google finance',NULL);
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',NULL,NULL,N'stock option',N'qoutes',NULL,N'msn',NULL);
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',NULL,NULL,NULL,N'quotes',NULL,N'yahoo finance',NULL);
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'RealTimeToExcel',N'quotes',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',N'export',N'*',N'*',N'*',N'*',N'excel',N'db2');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',N'import',NULL,NULL,N'data',NULL,NULL,N'ms sql');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',N'save',NULL,NULL,NULL,NULL,NULL,N'mysql');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',N'upload',NULL,NULL,NULL,NULL,NULL,N'oracle');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',NULL,NULL,NULL,NULL,NULL,NULL,N'sql server');
GO
INSERT INTO [KeywordModel] ([Campaign],[KeywordSet],[Col1],[Col2],[Col3],[Col4],[Col5],[Col6],[Col7]) VALUES (N'SaveToDB',N'import-export',NULL,NULL,NULL,NULL,NULL,NULL,N'sql server compact');
GO

INSERT INTO [QueryList] ([TABLE_CODE],[TABLE_NAME],[TABLE_TYPE],[INSERT_PROCEDURE],[UPDATE_PROCEDURE],[DELETE_PROCEDURE]) VALUES (N'SELECT
    m.Campaign
    , m.KeywordSet
    , m.Col1
    , m.Col2
    , m.Col3
    , m.Col4
    , m.Col5
    , m.Col6
    , m.Col7
    , LEN(m.Keyword) - LEN(REPLACE(m.Keyword, '' '', '''')) + 1  AS [Words]
    , LEN(m.Keyword) AS [Length]
    , m.Keyword
FROM
    (
        SELECT
            m1.Campaign
            , m1.KeywordSet
            , m1.Col1
            , m2.Col2
            , m3.Col3
            , m4.Col4
            , m5.Col5
            , m6.Col6
            , m7.Col7
            , LTRIM(RTRIM(REPLACE(CASE WHEN m1.Col1 = ''*'' THEN '''' ELSE m1.Col1 END
                + CASE WHEN m2.Col2 = ''*'' THEN '''' ELSE '' '' + m2.Col2 END
                + CASE WHEN m3.Col3 = ''*'' THEN '''' ELSE '' '' + m3.Col3 END
                + CASE WHEN m4.Col4 = ''*'' THEN '''' ELSE '' '' + m4.Col4 END
                + CASE WHEN m5.Col5 = ''*'' THEN '''' ELSE '' '' + m5.Col5 END
                + CASE WHEN m6.Col6 = ''*'' THEN '''' ELSE '' '' + m6.Col6 END
                + CASE WHEN m7.Col7 = ''*'' THEN '''' ELSE '' '' + m7.Col7 END
                , ''  '', '' ''))) AS Keyword
        FROM
            KeywordModel m1
            , KeywordModel m2
            , KeywordModel m3
            , KeywordModel m4
            , KeywordModel m5
            , KeywordModel m6
            , KeywordModel m7
        WHERE
            m1.Col1 IS NOT NULL
            AND m2.Col2 IS NOT NULL AND m2.Campaign = m1.Campaign AND m2.KeywordSet = m1.KeywordSet
            AND m3.Col3 IS NOT NULL AND m3.Campaign = m1.Campaign AND m3.KeywordSet = m1.KeywordSet
            AND m4.Col4 IS NOT NULL AND m4.Campaign = m1.Campaign AND m4.KeywordSet = m1.KeywordSet
            AND m5.Col5 IS NOT NULL AND m5.Campaign = m1.Campaign AND m5.KeywordSet = m1.KeywordSet
            AND m6.Col6 IS NOT NULL AND m6.Campaign = m1.Campaign AND m6.KeywordSet = m1.KeywordSet
            AND m7.Col7 IS NOT NULL AND m7.Campaign = m1.Campaign AND m7.KeywordSet = m1.KeywordSet
    ) m
WHERE
    m.Campaign = COALESCE(@Campaign, m.Campaign)
    AND m.KeywordSet = COALESCE(@KeywordSet, m.KeywordSet)
    AND (LEN(m.Keyword) - LEN(REPLACE(m.Keyword, '' '', '''')) + 1 = @Words OR @Words IS NULL)
',N'ModelKeywords',N'CODE',NULL,NULL,NULL);
GO

INSERT INTO [ParameterValues] ([TABLE_SCHEMA],[TABLE_NAME],[PARAMETER_NAME],[SELECT_CODE],[SELECT_NAME],[SELECT_TYPE]) VALUES (NULL,N'ModelKeywords',N'KeywordSet',N'SELECT NULL AS KeywordSet UNION ALL SELECT DISTINCT KeywordSet FROM KeywordModel',N'ModelKeywords_KeywordSet',N'CODE');
GO
INSERT INTO [ParameterValues] ([TABLE_SCHEMA],[TABLE_NAME],[PARAMETER_NAME],[SELECT_CODE],[SELECT_NAME],[SELECT_TYPE]) VALUES (NULL,N'ModelKeywords',N'Words',N'SELECT NULL AS Words UNION ALL SELECT 2 UNION ALL SELECT 3 UNION ALL SELECT 4 UNION ALL SELECT 5 UNION ALL SELECT 6 UNION ALL SELECT 7 UNION ALL SELECT 8',N'ModelKeywords_Words',N'CODE');
GO
INSERT INTO [ParameterValues] ([TABLE_SCHEMA],[TABLE_NAME],[PARAMETER_NAME],[SELECT_CODE],[SELECT_NAME],[SELECT_TYPE]) VALUES (NULL,N'ModelKeywords',N'Campaign',N'SELECT NULL AS Campaign UNION ALL SELECT DISTINCT Campaign FROM KeywordModel',N'ModelKeywords_Campaign',N'CODE');
GO

-- print Adwords Keyword Generator has been installed
