SELECT
    m.Campaign
    , m.KeywordSet
    , m.Col1
    , m.Col2
    , m.Col3
    , m.Col4
    , m.Col5
    , m.Col6
    , m.Col7
    , LEN(m.Keyword) - LEN(REPLACE(m.Keyword, ' ', '')) + 1  AS [Words]
    , LEN(m.Keyword) AS [Length]
    , m.Keyword
FROM
    (
        SELECT
            m1.Campaign
            , m1.KeywordSet
            , m1.Col1
            , m2.Col2
            , m3.Col3
            , m4.Col4
            , m5.Col5
            , m6.Col6
            , m7.Col7
            , LTRIM(RTRIM(REPLACE(CASE WHEN m1.Col1 = '*' THEN '' ELSE m1.Col1 END
                + CASE WHEN m2.Col2 = '*' THEN '' ELSE ' ' + m2.Col2 END
                + CASE WHEN m3.Col3 = '*' THEN '' ELSE ' ' + m3.Col3 END
                + CASE WHEN m4.Col4 = '*' THEN '' ELSE ' ' + m4.Col4 END
                + CASE WHEN m5.Col5 = '*' THEN '' ELSE ' ' + m5.Col5 END
                + CASE WHEN m6.Col6 = '*' THEN '' ELSE ' ' + m6.Col6 END
                + CASE WHEN m7.Col7 = '*' THEN '' ELSE ' ' + m7.Col7 END
                , '  ', ' '))) AS Keyword
        FROM
            KeywordModel m1
            , KeywordModel m2
            , KeywordModel m3
            , KeywordModel m4
            , KeywordModel m5
            , KeywordModel m6
            , KeywordModel m7
        WHERE
            m1.Col1 IS NOT NULL
            AND m2.Col2 IS NOT NULL AND m2.Campaign = m1.Campaign AND m2.KeywordSet = m1.KeywordSet
            AND m3.Col3 IS NOT NULL AND m3.Campaign = m1.Campaign AND m3.KeywordSet = m1.KeywordSet
            AND m4.Col4 IS NOT NULL AND m4.Campaign = m1.Campaign AND m4.KeywordSet = m1.KeywordSet
            AND m5.Col5 IS NOT NULL AND m5.Campaign = m1.Campaign AND m5.KeywordSet = m1.KeywordSet
            AND m6.Col6 IS NOT NULL AND m6.Campaign = m1.Campaign AND m6.KeywordSet = m1.KeywordSet
            AND m7.Col7 IS NOT NULL AND m7.Campaign = m1.Campaign AND m7.KeywordSet = m1.KeywordSet
    ) m
WHERE
    m.Campaign = COALESCE(@Campaign, m.Campaign)
    AND m.KeywordSet = COALESCE(@KeywordSet, m.KeywordSet)
    AND (LEN(m.Keyword) - LEN(REPLACE(m.Keyword, ' ', '')) + 1 = @Words OR @Words IS NULL)
