SET NOCOUNT ON

SELECT
    CAST(s.name AS VARCHAR(15)) AS [SCHEMA]
    , CAST(o.name AS VARCHAR(50)) AS [NAME]
    , CASE o.xtype WHEN 'U' THEN 'table' WHEN 'V' THEN 'view' WHEN 'P' THEN 'procedure' ELSE o.xtype END AS [TYPE]
FROM
    sysobjects o
    INNER JOIN sysusers s ON s.uid = o.uid
WHERE
    o.xtype IN ('U', 'V', 'P')
    AND s.name IN ('dbo30', 'xls30')
ORDER BY
    CASE o.xtype WHEN 'P' THEN  'Z' ELSE o.xtype END
    , s.uid
    , o.name
