CREATE ROLE [Payments30_Developers] AUTHORIZATION [dbo]
GO
CREATE ROLE [Payments30_Users] AUTHORIZATION [dbo]
GO

EXEC sp_addrolemember N'SaveToDB_Developers', N'Payments30_Developers'
GO
EXEC sp_addrolemember N'SaveToDB_Users', N'Payments30_Users'
GO

CREATE USER [Payments30_Developer] FOR LOGIN [payments30_Developer] WITH DEFAULT_SCHEMA=[dbo30]
GO
CREATE USER [Payments30_User] FOR LOGIN [payments30_User] WITH DEFAULT_SCHEMA=[xls30]
GO

EXEC sp_addrolemember N'Payments30_Developers', N'payments30_Developer'
GO
EXEC sp_addrolemember N'Payments30_Users', N'payments30_User'
GO

GRANT SELECT ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO
GRANT INSERT ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO
GRANT UPDATE ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO
GRANT DELETE ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO
GRANT EXECUTE ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO

GRANT SELECT ON SCHEMA::[etl30] TO [Payments30_Developers] AS [dbo]
GO
GRANT EXECUTE ON SCHEMA::[etl30] TO [Payments30_Developers] AS [dbo]
GO

GRANT SELECT ON SCHEMA::[xls30] TO [Payments30_Developers] AS [dbo]
GO
GRANT EXECUTE ON SCHEMA::[xls30] TO [Payments30_Developers] AS [dbo]
GO
GRANT SELECT ON SCHEMA::[xls30] TO [Payments30_Users] AS [dbo]
GO
GRANT EXECUTE ON SCHEMA::[xls30] TO [Payments30_Users] AS [dbo]
GO

GRANT VIEW DEFINITION ON SCHEMA::[dbo30] TO [Payments30_Developers] AS [dbo]
GO
GRANT VIEW DEFINITION ON SCHEMA::[xls30] TO [Payments30_Developers] AS [dbo]
GO
GRANT VIEW DEFINITION ON SCHEMA::[etl30] TO [Payments30_Developers] AS [dbo]
GO

GRANT SELECT ON [dbo30].[Payment] TO [Payments30_Users] AS [dbo]
GO
GRANT INSERT ON [dbo30].[Payment] TO [Payments30_Users] AS [dbo]
GO
GRANT UPDATE ON [dbo30].[Payment] TO [Payments30_Users] AS [dbo]
GO
GRANT DELETE ON [dbo30].[Payment] TO [Payments30_Users] AS [dbo]
GO

IF EXISTS(SELECT * FROM sys.database_principals WHERE name = 'DbManagement05_Users')
    BEGIN
    GRANT VIEW DEFINITION ON SCHEMA::[dbo30] TO [DbManagement05_Users] AS [dbo]
    GRANT VIEW DEFINITION ON SCHEMA::[xls30] TO [DbManagement05_Users] AS [dbo]
    GRANT VIEW DEFINITION ON SCHEMA::[etl30] TO [DbManagement05_Users] AS [dbo]

    GRANT VIEW DEFINITION ON ROLE::[Payments30_Developers]  TO [DbManagement05_Users] AS [dbo]
    GRANT VIEW DEFINITION ON ROLE::[Payments30_Users]       TO [DbManagement05_Users] AS [dbo]

    GRANT VIEW DEFINITION ON USER::[Payments30_Developer]   TO [DbManagement05_users]
    GRANT VIEW DEFINITION ON USER::[Payments30_User]        TO [DbManagement05_users]
    END
GO
