SELECT

    b.ID

    , d.Code AS DepartmentCode

    , i.Code AS ItemCode

    , CASE WHEN LEN(i.Code) > 2 THEN '    ' + i.Name WHEN SUBSTRING(i.Code, LEN(i.Code), 1) = '0' THEN i.Name ELSE '  ' + i.Name END AS ItemName

    , CAST(p.[Date] AS datetime) AS [Date]

    , b.Amount

    , b.[Sum]

FROM

    Department d

    CROSS JOIN Period p

    CROSS JOIN Item i

    LEFT OUTER JOIN Budget b ON p.[Date] = b.[Date] AND d.Code = b.DepartmentCode AND i.Code = b.ItemCode

WHERE

    d.Code = COALESCE(@DepartmentCode, d.Code)

    AND i.Code = COALESCE(@ItemCode, i.Code)

    AND p.[Date] = COALESCE(@Date, p.[Date])

ORDER BY

    DepartmentCode

    , [Date]

    , ItemCode

